%% thes routine create a movie of all the trajs that appear in the tabel
%% "controllo_tabella" that refer to the target "Punto_iniziale" set in the
%% routine E_checkcrossings.m
%% the avi file is stored as "TEST#.avi" where # is Punto_iniziale.

%% internal: puntomesso is the variable in which are stored the distinct
%% targets that are displayed and is used to create the circles.
%% it also assign an order to the targets whoses trajs are displayed in 3D 
%% by the routine H_track_3D.m
lut_flag = 1; % lut_flag = 0 --> jet, lut_flag = 1 --> hot
clear dalfiltrare1
FaiDafiltrare1=0; % set 0 to spare some time if run more than once.

High_T = 12480; % for SLN
%High_T = 424; % for Lymphonodes

a      = numero; % number of frames to be mounted
max_tab= 30; %% maximum number of targets to be linked to the target that is analysed currently.
%%%% selection of the colormaps 
cmap1=zeros(256,3);
cmap2=zeros(128,3);
% define cmap1 
if (lut_flag==0) 
    cmap = colormap(jet(128)); %% this for the image Jet lut
else
    cmap = colormap(gray(128)); %% this for the image GRAYScale
end
close
% define cmap2
cmap2 = colormap(hsv(128)); %% this for the circles that identify the targets
% assemble the final lut cmap1
cmap1(1:128,:)   = cmap;
cmap1(129:256,:) = cmap2;
cmap1(256,:)     = [1 1 1];

%%% END OF INPUT

%clear Htempo3
nomefile= sprintf('TEST%2d.avi',Punto_iniziale); %change path if you like or must
%dafiltrare = rd_img16('/home/uomonero/Scrivania/Progetti/scan_t_4.tif');
[tempo,coord,punti] = size(fine);
[paragonef i] = size(controllo_tabella);

if FaiDafiltrare1==1         %% for low memory work directly on dafiltrare
    dafiltrare1=dafiltrare;          
 for i=1:numero,
    for k=1: 256
        for j=1: 256

            if dafiltrare1(k,j,i)>High_T
            dafiltrare1(k,j,i)=High_T; %% for low memeory 
%%            if dafiltrare(k,j,i)>High_T dafiltrare(k,j,i)=High_T;
            end
        end
    end
 end
 q= double(dafiltrare1); %% for large memory 
else
 for i=1:numero,
    for k=1: 256
        for j=1: 256
            if dafiltrare(k,j,i)>High_T dafiltrare(k,j,i)=High_T;
            end
        end
    end
 end
 q= double(dafiltrare); %% for large memory 
end

%% q= double(dafiltrare);
q = q / max(max(max(q)));

f=zeros(256,256,a);
velocita=zeros(256,256);
puntomesso=zeros(60,3); %% to be changed in order to generalize

tony=1;
puntomesso(tony,1)=Punto_iniziale; %% first set the chosen target 
puntomesso(tony,2)=fine(1,3,Punto_iniziale); %% and its position
puntomesso(tony,3)=fine(1,2,Punto_iniziale);
tony = 2;
for i=1:paragonef
    if controllo_tabella(i,1)==Punto_iniziale %% just to do something...      
            if puntomesso(tony-1,1)~=controllo_tabella(i,5) && puntomesso(tony-1,2)~=fine(1,3,controllo_tabella(i,5)) && puntomesso(tony-1,3)~=fine(1,2,controllo_tabella(i,5))
                puntomesso(tony,1)=controllo_tabella(i,5);
                puntomesso(tony,2)=fine(1,3,controllo_tabella(i,5));
                puntomesso(tony,3)=fine(1,2,controllo_tabella(i,5)); %% put the other targets
                tony=tony+1;
            end
    end
end


for i=1:a
    f(:,:,i)=q(:,:,i);
end
clear q;

f=f/max(max(max(f)));
%f=1+f(:,:,:).*255;  % these two lines set the 255 levels on the original image of the stack
f=f(:,:,:).*128;  % these two lines set the 255 levels on the original image of the stack
colormap(cmap1);
%% now start creating the movie with all the targets' trajs
%for i=1:punti
fig=figure; % open figure
set(fig,'DoubleBuffer','on');
set(gca,'xlim',[-80 80],'ylim',[-80 80],'NextPlot','replace','Visible','off');
%nomefile;
%aviobj = avifile(nomefile,'fps', 10); %last number is the frame per second, 25 FPS is pal dvd 
aviobj = avifile('Gmovie','fps', 10); %last number is the frame per second, 25 FPS is pal dvd 

% now create the circles around the targets

for i = 1 : a

    for j=1:max_tab      %% this loop draw the circles on the image
        if puntomesso(j,1)~=0,
            selezionatore=0;
            h=1;
            %testo3=sprintf('%2.0f',puntomesso(j,1));
            while selezionatore==0 
%                 if fine(h+1,1,puntomesso(j,1))-fine(h,1,puntomesso(j,1))<10
                if fine(h,1,puntomesso(j,1))>=i
                    
                    selezionatore=1;
                                    
                    pts=circlepoints(fine(h,2,puntomesso(j,1)),fine(h,3,puntomesso(j,1)),4);
               
                    for e=1:24;
                        f(pts(e,1), pts(e,2), i) = 257-3*j;
                    end
                    
                end
%                 end
                h=h+1;
                 if h>99 selezionatore=1; end
            end
        end
    end

    image(f(:,:,i));
    colormap(cmap1); %% this display the image

    K(i) = getframe; %% this store the display
    aviobj = addframe(aviobj,K(i)); %% this add the frame to the avi file.

end;

close 

aviobj = close(aviobj);
implay (K);

